#include "oak.h"
#include <stdlib.h>

#define INITSIZE 30
#define GROWAT 2
#define GROWBY 1.5

int oak_list_create(oak_list *l) {
  l->size=0;
  l->list=(void **)malloc(INITSIZE*sizeof(void *));
  l->avail=INITSIZE;
  if (l->list==NULL) return(-1);
  return(0);
}

int oak_list_get_size(oak_list *l) {
  return(l->size);
}

void *oak_list_get_element(oak_list *l, int n) {
  if (n>l->size-1) return(NULL);
  return(l->list[n]);
}

int oak_list_append_element(oak_list *l, void *element) {
  if ((l->size+1) > (l->avail/GROWAT)) {
    l->list=realloc(l->list, l->avail*GROWBY*sizeof(void *));
    l->avail=l->avail*GROWBY;
    if (l->list==NULL) return(-1);
  }

  l->list[l->size]=element;
  l->size++;
  return(0);
}

int oak_list_remove_element(oak_list *l, int n) {
  int i;

  if (n>l->size-1) return(-1);
  for (i=n; i<l->size-1; i++) {
    l->list[i]=l->list[i+1];
  }
  l->size--;
  return(0);
}

void oak_list_free_all(oak_list *l, void (*elefree)(void *)) {
  int i;

  for (i=0; i<l->size; i++) {
    (elefree)(l->list[i]);
  }
  free(l->list);
}

void oak_list_free_simple(oak_list *l) {
  if (l->list) free(l->list);
}

